/*
 * AL.H
 *
 *  Header file for ArchiveLib 1.0
 *
 *  Copyright (c) 1994 Greenleaf Software, Inc.
 *  All Rights Reserved
 *
 * DESCRIPTION
 *
 *  This is the master file that you can use to include
 *  all of the ArchiveLib headers.  If you are using precompiled
 *  headers with your compiler, this might be the file you want
 *  included first in all your source files.
 * 
 * REVISION HISTORY
 *
 *  May 26, 1994  1.0A  : First release
 *
 */

#ifndef _AL_H
#define _AL_H

#include "arclib.h"

/* 
 * Derived classes 
 */

#include "filestor.h"
#include "memstore.h"
#include "copyengn.h"
#include "grenengn.h"
#include "archive.h"

/* 
 * Demo classes and functions 
 */

#if defined( AL_WINDOWS_GUI )
  #include "winmon.h"
  #include "algauge.h"
  #include "alstream.h"
#else
  #include "bargraph.h"
  #include "spinner.h"
#endif

/*
 * Additional classes 
 */
#include "wildcard.h"

#endif /* #ifdef _AL_H */
