#include <applicat.h>
#include <mask.h>
#include <urldefid.h>

#include "cg2200.h"
#include "cg2101.h"

#include <mov.h>
#include <rmov.h>
#include <rmoviva.h>

class TDeleteprovv_app : public TApplication
{ 
protected:
  virtual bool create();
  virtual bool destroy();
  virtual bool menu(MENU_TAG m);  
  
public:
  TDeleteprovv_app() {};  
};

bool TDeleteprovv_app::create()
{
  dispatch_e_menu(BAR_ITEM(1));
  return TRUE;
}

bool TDeleteprovv_app::destroy()
{
  return TRUE;
}

bool TDeleteprovv_app::menu(MENU_TAG)
{
  TLocalisamfile mov(LF_MOV), rmov(LF_RMOV), rmoviva(LF_RMOVIVA); 
  TMask m("cg2200a");
  
  while (m.run() != K_QUIT) 
  { 
    mov.setkey(2);
    rmov.setkey(1);
    rmoviva.setkey(1);
    
    TRectype to(mov.curr());
    to.zero();
    to.put(MOV_DATAREG, m.get(F_TODATE));
    to.put(MOV_NUMREG, m.get(F_TOREG));
    
    mov.zero();
    mov.put(MOV_DATAREG, m.get(F_FROMDATE)); 
    mov.put(MOV_NUMREG, m.get(F_FROMREG)); 
    for (mov.read(_isequal, _lock); mov.good(); mov.next())
    {
      if (mov.curr() > to) break;
      const long numreg = mov.get_long(MOV_NUMREG);
      for (int rig = 1; ; rig++)
      {
        rmov.put(RMV_NUMREG, numreg);
        rmov.put(RMV_NUMRIG, rig);
        if (rmov.read(_isequal, _lock) != NOERR) break;
        rmov.remove();
      }  
      for (rig = 1; ; rig++)
      {
        rmov.put(RMI_NUMREG, numreg);
        rmoviva.put(RMI_NUMRIG, rig);
        if (rmoviva.read(_isequal, _lock) != NOERR) break;
        rmov.remove();
      }  
      mov.remove();
    }
  }
  
  return FALSE;
}


int cg2200(int argc, char** argv)
{
  TDeleteprovv_app a;
  a.run(argc, argv, "Cancellazione movimenti provvisori");
  return 0;
}