// cglib03.h
// TRigaiva_array 
// Tabella per il calcolo degli imponibili Iva

#ifndef __CGLIB03_H
#define __CGLIB03_H

#include <array.h>
#include <real.h>
#include <strings.h>

struct TDociva : public TObject
{
  TString _descrdoc;
  real _totdociva;
  int _ndoc;

  TDociva(const char* _descrdociva, const real& _importo,const int _natdoc):_descrdoc(_descrdociva),_totdociva(_importo),_ndoc(_natdoc)
  {}
};

class TDociva_array : public TArray
{
public:
bool add_riga(const char* _descrdociva,const real& _importo,const int _natdoc);
};

struct TRigaiva : public TObject
{
 real     _imponibile, _imposta, _imponibilep, _impostap; //imponibili, imposte del periodo e progressivi
 TString  _codiva;
 int      _tipodet;
 
 TRigaiva (const real& imponibile, const real& imposta, const char* codiva, int tipodet, const real& imponibilep, const real& impostap):
 _imponibile(imponibile),_imposta(imposta),_codiva(codiva),_tipodet(tipodet),_imponibilep(imponibilep),_impostap(impostap)
          {} 
};
  
class TRigaiva_array : public TArray
{
 public:
 bool add_riga(const real& imponibile, const real& imposta, const char* codiva, const int tipodet, const real& imponibilep, const real& impostap); 
};
  
struct TTipodoc : public TObject
{
  TString _tipodoc, _descrdoc;
  real    _totdoc;
  
  TTipodoc (const char* tipodoc, const char* descrdoc, const real& totdoc):
  _tipodoc(tipodoc),_descrdoc(descrdoc),_totdoc(totdoc) {}
};

class TTipodoc_array : public TArray
{
 public:
 bool add_riga(const char* tipodoc, const char* descrdoc, const real& totdoc);  
};

struct TRiga : public TObject
{
 real     _imponibile, _imposta, _imponibilep, _impostap;
 TString  _codiva;
 
 TRiga (const real& imponibile, const real& imposta, const char* codiva, const real& imponibilep, const real& impostap):
 _imponibile(imponibile),_imposta(imposta),_codiva(codiva),_imponibilep(imponibilep),_impostap(impostap) {} 
};

class TRiga_array : public TArray
{
 public:
 bool add_riga(const real& imponibile, const real& imposta, const char* codiva, const real& imponibilep, const real& impostap); 
};  
  
#endif
