#ifndef __TABUTIL_H
#define __TABUTIL_H

#ifndef __ISAM_H
#include <isam.h>
#endif 

/*
   @(SH) Header

   @(C#) PUBBLICHE

   @(C$) PRIVATE
   @(VG#) PUBBLICHE
   @(VG$) PRIVATE
   */

// @C
// Classe TTable : public TLocalisamfile
// @END

class TTable : public TLocalisamfile
{
  // @DPRIV
  TString       _tabname;

public:
  // @FPUB
  int first(word lockop = _nolock);
  int last(word lockop = _nolock);
  int next(word lockop = _nolock);
  int prev(word lockop = _nolock);
  int reread(word lockop = _nolock, TDate& = (TDate&)botime);
  int reread(TRectype& rec, word lockop = _nolock, TDate& = (TDate&)botime);
  int skip(TRecnotype nrec, word lockop = _nolock);
  int read(word op = _isequal, word lockop = _nolock, TDate& = (TDate&)botime);
  int read(TRectype& rec, word op = _isequal, word lockop = _nolock, TDate& = (TDate&)botime);
  int readat(TRecnotype nrec, word lockop = _nolock);
  int readat(TRectype& rec, TRecnotype nrec, word lockop = _nolock);
  int write(TDate& = (TDate&)botime);
  int write(const TRectype& rec, TDate& = (TDate&)botime);
  int rewrite(TDate& = (TDate&)botime);
  int rewrite(const TRectype& rec, TDate& = (TDate&)botime);
  int remove(TDate& = (TDate&)botime);
  int remove(const TRectype& rec, TDate& = (TDate&)botime);

  virtual const char* name() const { return (const char*) _tabname;}

  TTable(const char* tabname, bool linkrecinst = FALSE);
  virtual ~TTable() {}

  static int name2log(const char* tabname);
};


#endif // __TABUTIL_H
